Data ADSl ;
	Length STUDYID $200	DOMAIN $200	USUBJID $200	SUBJID $200	SITEID $200	BRTHDTC $200	AGE 8	AGEU $200	AGEGR1 $200	
SEX $200	RACE $200	ETHNIC $200	ARMCD $200	ARM $200	ACTARMCD $20	ACTARM $200	SAFFL $2	SAFXL $200	PKFL $2	
PKXL $200	ENRLFL $2	POP01FL $2	PARTAFL $2	PARTBFL $2	POP02FL $2	GROUP01 $40	COMPLFL $2	COMPLFLD $40	COMPTRFL $2	
COMPTRFD $40	RFSTDTC $19	RFENDTC $19	RFXSTDTC  $19	RFXENDTC  $19	RFPENDTC  $19	COUNTRY $200	DTHFL $200	
DTHDTC $200	DTHDY 8	BLBMI 8	BLHGHT 8	BLWGHT 8	BLECOG $200	BLECOGN 8	TRT01A $200	TRT02A $200	TRT03A $200	
TRT01P $200	TRT02P $200	TRT03P $200	TR01SDTM 8	TR01EDTM 8	TR02SDTM 8	TR02EDTM 8	TR03SDTM 8	TR03EDTM 8	TRTSDTM 8	
TRTEDTM 8	TRTSDT 8	TRTEDT 8	TR01SDT 8	TR01EDT 8	TR02SDT 8	TR02EDT 8	TR03SDT 8	TR03EDT 8 ;
	Set ADAM.ADSL (rename=(SUBJID = SUBJID1 SITEID = SITEID1 TR02SDTM=TR02SDTM1 TR02EDTM = TR02EDTM1 TR03SDTM=TR03SDTM1
						   TR03EDTM = TR03EDTM1));

	SUBJID = put(SUBJID1,8.) ;
	SITEID = put(SITEID1,8.) ;
	TR02SDTM = input(TR02SDTM1,yymmdd10.) ;
	TR02EDTM = input(TR02EDTM1,yymmdd10.) ;
	TR03SDTM = input(TR03SDTM1,yymmdd10.) ;
	TR03EDTM = input(TR03EDTM1,yymmdd10.) ;
Run ;

data ae ;
	length USUBJID $200 ; 
	set sdtm.ae ;
run;


data ADAE1;
  merge adsl(in=a drop=studyid domain) AE(in=b);
  by usubjid;
  length AAE001FL aeevnt02 aeevnt03 AAE003FL AAE004FL aeevnt14 AAE007FL AAE009FL aeevnt32 AAE014FL prefl trtemafl trtembfl postafl postbfl $2
      aperiod adurn 8 aperiodc $40 aduru $10;
  if a and b;

  if ^missing(AETERM) then AAE001FL = "Y"; else AAE001FL = "N";
  if AEREL = "Y" then AEEVNT02 = "Y"; else AEEVNT02 = "N";
  if AEACN in ('DOSE REDUCED','DRUG INTERRUPTED') then AEEVNT03 = "Y"; else AEEVNT03 = "N";
  if AESER="Y" then AAE003FL = "Y"; else AAE003FL = "N";
  if index(upcase(AEOUT),"DEATH")>0 or index(upcase(AEOUT),"FATAL")>0 or AESDTH="Y" then AAE004FL = "Y"; else AAE004FL = "N";

  If AEACN in ('DRUG WITHDRAWN') then AEEVNT14 = "Y"; else AEEVNT14 = "N"; 
  if AEACN in ('DRUG INTERRUPTED') then AAE007FL = "Y"; else AAE007FL = "N";
  if AESDISAB="Y" then AAE009FL = "Y"; else AAE009FL = "N";
  if input(strip(AETOXGR),best.)>=3 then AEEVNT32 = "Y"; else AEEVNT32 = "N";
  if AEACN in ('DOSE REDUCED') then AAE014FL = "Y"; else AAE014FL = "N";

/*temporary time variables for using in derivations*/
  if length(AESTDTC)>=10 then ADT = input(substr(AESTDTC,1,10),yymmdd10.);
  format ADT yymmdd10.;
  if length(AESTDTC)>=16 then do;
    ATM = input(substr(AESTDTC,12,5),time5.);
    ADTM = dhms(ADT,0,0,ATM);
  end;
  format ATM time5.;
  format ADTM datetime19.;

  if length(AEENDTC)>=10 then AEDT = input(substr(AEENDTC,1,10),yymmdd10.);
  format AEDT yymmdd10.;
  if length(AEENDTC)>=16 then AETM = input(substr(AEENDTC,12,5),time5.);
  format AETM time5.;

/*Pre-treatment flag*/  
  if cmiss(adt,trtsdt)=0 then do;
	if ADT<TRTSDT then PREFL="Y";
	else prefl="N";
  end;

/*Treatment emergency and post treamtns flags*/  
  if partafl="Y" and partbfl="N" and pop02fl="N" then do;
    if .<TR01SDT<=ADT<=TR01EDT+30 then TRTEMAFL="Y";else TRTEMAFL="N";
    if ADT>TR01EDT+30 then POSTAFL="Y";else POSTAFL="N";
    TRTEMBFL = "N";
    POSTBFL = "N";
  end;
  else if partafl="Y" and partbfl="Y" and pop02fl="N" then do;
    if .<TR01SDT<=ADT<tr02sdt then TRTEMAFL="Y";else TRTEMAFL="N";
    if ADT>TR01EDT+30 and ADT<TR02SDT then POSTAFL="Y";else POSTAFL="N";

    if TR02EDT NE . AND .<TR02SDT<=ADT<=TR02EDT+30 then TRTEMBFL="Y";  
	else TRTEMBFL="N";

    if TR02EDT NE . AND ADT>TR02EDT+30 then POSTBFL="Y"; 
	else POSTBFL="N";
  end;

  else if partafl="Y" and partbfl="Y" and pop02fl="Y" then do;
    if .<TR01SDT<=ADT<tr02sdt then TRTEMAFL="Y";else TRTEMAFL="N";
    if ADT>TR01EDT+30 and ADT<TR02SDT then POSTAFL="Y";else POSTAFL="N";
    if  .<TR02SDT<=ADT<tr03sdt then TRTEMBFL="Y";
	else TRTEMBFL="N";
    if (TR02EDT NE . AND ADT>TR02EDT+30) and ADT<tr03sdt then POSTBFL="Y";
	else if ADT>trtedt+30 and ADT<tr03sdt then POSTBFL="Y";
	else POSTBFL="N";
  end;
  else if partafl="Y" and partbfl="N" and pop02fl="Y" then do;
    if .<TR01SDT<=ADT<tr03sdt then TRTEMAFL="Y";else TRTEMAFL="N";
    if ADT>TR01EDT+30 and ADT<tr03sdt then POSTAFL="Y";else POSTAFL="N";
    TRTEMBFL = "N";
    POSTBFL = "N";
  end;
/*ADURN and ADURU*/
  if nmiss(ADT,AEDT)=0 then do;  
    ADURN = AEDT - ADT + 1;
    ADURU = "Days";
  end;

  %MACRO prd_aperiod(onset=ADT,conttrt=TR03SDT);
 length aperiodc $40;
  if partafl="Y" and partbfl="Y" and pop02fl="Y" then do;
    if &onset.<TR02SDT then APERIOD=1;
    else if &onset.<&conttrt. then APERIOD=2;
    else if &onset.>=&conttrt. then APERIOD=3;
  end;
  else if partafl="Y" and partbfl="Y" and pop02fl="N" then do;
    if &onset.<TR02SDT then APERIOD=1;
    else if .<&onset.<=(trtedt+37) then APERIOD=2;
  end;
  else if partafl="Y" and partbfl="N" and pop02fl="Y" then do;
    if &onset.<&conttrt. then APERIOD=1;
  else APERIOD=3;
  end;
  else if partafl="Y" and partbfl="N" and pop02fl="N" then do;
     if .<&onset.<=(trtedt+37) then APERIOD=1;
  end;

  if APERIOD=1 then APERIODC="Part A";
  else if APERIOD=2 then APERIODC="Part B";
  else if APERIOD=3 then APERIODC="Continued Access";
 	
%MEND;
%prd_aperiod;
run; 
proc sort;by usubjid aeseq;run;

data ex;
  set sdtm.ex;
  where EXTRT in("Dummy"); 
  keep USUBJID EXDOSE EXDOSTOT EXSTDTC EXSTDTN;
  format EXSTDTN  yymmdd10.;

  EXSTDTN = input(EXSTDTC,??yymmdd10.);

run;

proc sort data = ex presorted;
  by USUBJID EXDOSE EXSTDTN;
run;

proc transpose data = ex out = ex_tr(drop=_NAME_) prefix = ex_;
  by USUBJID EXDOSE; 
  var EXSTDTN;
run;

data adae2;
  merge adae1(in=a)
        ex_tr(in=b);
  by USUBJID;
  if a;

/*DOSEON*/
  if aestdy>=0 and (input(AESTDTC,??yymmdd10.) >= EX_2) or (input(AESTDTC,??yymmdd10.) >= EX_1) then DOSEON = EXDOSE;

/*DOSAEONU*/
  if ^missing(DOSEON) then DOSAEONU = "mg";
run;



Data adae3 ;
Length STUDYID $200	DOMAIN $200	USUBJID $200	SUBJID $200	SITEID $200	BRTHDTC $200	AGE 8	AGEU $200	AGEGR1 $200	
SEX $200	RACE $200	ETHNIC $200	ARMCD $200	ARM $200	ACTARMCD $20	ACTARM $200	SAFFL $2	SAFXL $200	PKFL $2	
PKXL $200	ENRLFL $2	POP01FL $2	PARTAFL $2	PARTBFL $2	POP02FL $2	GROUP01 $40	COMPLFL $2	COMPLFLD $40	COMPTRFL $2	
COMPTRFD $40	RFSTDTC $19	RFENDTC $19	RFXSTDTC  $19	RFXENDTC  $19	RFPENDTC  $19	COUNTRY $200	DTHFL $200	
DTHDTC $200	DTHDY 8	BLBMI 8	BLHGHT 8	BLWGHT 8	BLECOG $200	BLECOGN 8	TRT01A $200	TRT02A $200	TRT03A $200	
TRT01P $200	TRT02P $200	TRT03P $200	TR01SDTM 8	TR01EDTM 8	TR02SDTM 8	TR02EDTM 8	TR03SDTM 8	TR03EDTM 8	TRTSDTM 8	
TRTEDTM 8	TRTSDT 8	TRTEDT 8	TR01SDT 8	TR01EDT 8	TR02SDT 8	TR02EDT 8	TR03SDT 8	TR03EDT 8 AESEQ  8	
AESPID  $40	AETERM  $200	AELLT  $200	AELLTCD  8	AEDECOD  $200	AEPTCD  8	AEHLT  $200	AEHLTCD  8	AEHLGT  $200	
AEHLGTCD  8	AECAT $200	AEBODSYS  $200	AEBDSYCD  8	AESOC  $200	AESOCCD  8	AESER  $1	AEACN  $200	AEREL  $200	
AERELNST  $200	AEOUT  $200	AESCONG  $2	AESDISAB  $2	AESDTH  $2	AESHOSP  $2	AESLIFE  $2	AESMIE  $2	AECONTRT  $2	
AETOXGR  $200	AESTDTC  $19	AEENDTC  $19	AESTDY  8	AEENDY  8	AEENRTPT  $40	AEENTPT  $40	
AAE001FL $2	AEEVNT02 $2	AEEVNT03 $2	AAE003FL $2	AAE004FL $2	AEEVNT14 $2	AAE007FL $2	AAE009FL $2	AEEVNT32 $2	AAE014FL $2	
ADURN 8	ADURU $10	DOSEON 8	DOSAEONU $10	PREFL $2	TRTEMAFL $2	TRTEMBFL $2	POSTAFL $2	POSTBFL $2	APERIOD 8	
APERIODC $40 ;
	set adae2;

Label STUDYID = "Study Identifier"
DOMAIN = "Domain Abbreviation"
USUBJID = "Unique Subject Identifier"
SUBJID = "Subject Identifier for the Study"
SITEID = "Study Site Identifier"
BRTHDTC = "Date/Time of Birth"
AGE = "Age"
AGEU = "Age Units"
AGEGR1 = "Pooled Age Group 1"
SEX = "Sex"
RACE = "Race"
ETHNIC = "Ethnicity"
ARMCD = "Planned Arm Code"
ARM = "Description of Planned Arm"
ACTARMCD = "Actual Arm Code"
ACTARM = "Description of Actual Arm"
SAFFL = "Safety Population Flag"
SAFXL = "Reason for Excl. from Safety Pop"
PKFL = "Pharmacokinetics Population Flag"
PKXL = "Reason for Excl from PK Pop"
ENRLFL = "Enrolled Population Flag"
POP01FL = "Screened Population Flag"
PARTAFL = "Participation in Period 01"
PARTBFL = "Participation in Period 02"
POP02FL = "Ongoing into Continued Access"
GROUP01 = "Grouping Variable 01 Description"
COMPLFL = "Completers Population Flag"
COMPLFLD = "Completers Population Flag Description"
COMPTRFL = "Subject Completed Treatment"
COMPTRFD = "Subject Completed Treatment Description"
RFSTDTC = "Subject Reference Start Date/Time"
RFENDTC = "Subject Reference End Date/Time"
RFXSTDTC  = "Date/Time of First Study Treatment "
RFXENDTC  = "Date/Time of Last Study Treatment "
RFPENDTC  = "Date/Time of End of Participation "
COUNTRY = "Country"
DTHFL = "Subject Death Flag"
DTHDTC = "Date/Time of Death"
DTHDY = "Study Day of Death"
BLBMI = "Baseline Body Mass Index (kg/m**2)"
BLHGHT = "Baseline Height (cm)"
BLWGHT = "Baseline Weight (kg)"
BLECOG = "Baseline WHO performance status"
BLECOGN = "Baseline WHO performance status (N)"
TRT01A = "Actual Treatment for Period 01"
TRT02A = "Actual Treatment for Period 02"
TRT03A = "Actual Treatment for Period 03"
TRT01P = "Planned Treatment for Period 01"
TRT02P = "Planned Treatment for Period 02"
TRT03P = "Planned Treatment for Period 03"
TR01SDTM = "DateTime of First Exposure in Period 01"
TR01EDTM = "DateTime of Last Exposure in Period  01"
TR02SDTM = "DateTime of First Exposure in Period 02"
TR02EDTM = "DateTime of Last Exposure in Period 02"
TR03SDTM = "DateTime of First Exposure in Period 03"
TR03EDTM = "DateTime of Last Exposure in Period 03"
TRTSDTM = "DateTime of First Exposure to treatment"
TRTEDTM = "DateTime of Last Exposure to treatment"
TRTSDT = "Date of First Exposure to treatment"
TRTEDT = "Date of Last Exposure to treatment"
TR01SDT = "Date of First Exposure in Period 01"
TR01EDT = "Date of Last Exposure in Period 01"
TR02SDT = "Date of First Exposure in Period 02"
TR02EDT = "Date of Last Exposure in Period 02"
TR03SDT = "Date of First Exposure in Period 03"
TR03EDT = "Date of Last Exposure in Period 03"
AESEQ  = "Sequence Number"
AESPID  = "Sponsor-Defined Identifier"
AETERM  = "Reported Term for the Adverse Event"
AELLT  = "Lowest Level Term"
AELLTCD  = "Lowest Level Term Code"
AEDECOD  = "Dictionary-Derived Term"
AEPTCD  = "Preferred Term Code"
AEHLT  = "High Level Term"
AEHLTCD  = "High Level Term Code"
AEHLGT  = "High Level Group Term"
AEHLGTCD  = "High Level Group Term Code"
AECAT = "Category for Adverse Event"
AEBODSYS  = "Body System or Organ Class"
AEBDSYCD  = "Body System or Organ Class Code"
AESOC  = "Primary System Organ Class"
AESOCCD  = "Primary System Organ Class Code"
AESER  = "Serious Event"
AEACN  = "Action Taken with Study Treatment"
AEREL  = "Causality "
AERELNST  = "Relationship to Non-Study Treatment"
AEOUT  = "Outcome of Adverse Event"
AESCONG  = "Congenital Anomaly or Birth Defect"
AESDISAB  = "Persist or Signif Disability/Incapacity"
AESDTH  = "Results in Death"
AESHOSP  = "Requires or Prolongs Hospitalization"
AESLIFE  = "Is Life Threatening"
AESMIE  = "Other Medically Important Serious Event"
AECONTRT  = "Concomitant or Additional Trtmnt Given"
AETOXGR  = "Standard Toxicity Grade"
AESTDTC  = "Start Date/Time of Adverse Event"
AEENDTC  = "End Date/Time of Adverse Event"
AESTDY  = "Study Day of Start of Adverse Event"
AEENDY  = "Study Day of End of Adverse Event"
AEENRTPT  = "End Relative to Reference Time Point"
AEENTPT  = "End Reference Time Point"
AAE001FL = "Adverse Event"
AEEVNT02 = "Causally Related AE"
AEEVNT03 = "Dose Interrupted/Reduction AE ABC"
AAE003FL = "Serious Adverse Event"
AAE004FL = "SAE Leading to Death"
AEEVNT14 = "AE Disc Study Trt IP"
AAE007FL = "AE Leading to IP Tmp Stopped"
AAE009FL = "Other Significant AE"
AEEVNT32 = "AE with CTC Grade >=3"
AAE014FL = "AE Leading to Dose IP Reduced"
ADURN = "Analysis Duration (N)"
ADURU = "Analysis Duration Units"
DOSEON = "Treatment Dose at Record Start"
DOSAEONU = "Study Drug Dose at AE Onset Units"
PREFL = "Pre-treatment Flag"
TRTEMAFL = "Trt Emergent Analysis Flag Period 01"
TRTEMBFL = "Trt Emergent Analysis Flag Period 2"
POSTAFL = "Post-treatment Flag Period 1"
POSTBFL = "Post-treatment Flag Period 02"
APERIOD = "Period"
APERIODC = "Period (C)" ;

Keep STUDYID	DOMAIN	USUBJID	SUBJID	SITEID	BRTHDTC	AGE	AGEU	AGEGR1	SEX	RACE	ETHNIC	ARMCD	ARM	ACTARMCD	
ACTARM	SAFFL	SAFXL	PKFL	PKXL	ENRLFL	POP01FL	PARTAFL	PARTBFL	POP02FL	GROUP01	COMPLFL	COMPLFLD	COMPTRFL	
COMPTRFD	RFSTDTC	RFENDTC	RFXSTDTC 	RFXENDTC 	RFPENDTC 	COUNTRY	DTHFL	DTHDTC	DTHDY	BLBMI	BLHGHT	BLWGHT	
BLECOG	BLECOGN	TRT01A	TRT02A	TRT03A	TRT01P	TRT02P	TRT03P	TR01SDTM	TR01EDTM	TR02SDTM	TR02EDTM	TR03SDTM	
TR03EDTM	TRTSDTM	TRTEDTM	TRTSDT	TRTEDT	TR01SDT	TR01EDT	TR02SDT	TR02EDT	TR03SDT	TR03EDT	AESEQ 	AESPID 	AETERM 	AELLT 	
AELLTCD 	AEDECOD 	AEPTCD 	AEHLT 	AEHLTCD 	AEHLGT 	AEHLGTCD 	AECAT	AEBODSYS 	AEBDSYCD 	AESOC 	AESOCCD 	
AESER 	AEACN 	AEREL 	AERELNST 	AEOUT 	AESCONG 	AESDISAB 	AESDTH 	AESHOSP 	AESLIFE 	AESMIE 	AECONTRT 	
AETOXGR 	AESTDTC 	AEENDTC 	AESTDY 	AEENDY 	AEENRTPT 	AEENTPT 	AAE001FL	AEEVNT02	AEEVNT03	AAE003FL	
AAE004FL	AEEVNT14	AAE007FL	AAE009FL	AEEVNT32	AAE014FL	ADURN	ADURU	DOSEON	DOSAEONU	PREFL	
TRTEMAFL	TRTEMBFL	POSTAFL	POSTBFL	APERIOD	APERIODC ;
run ;

Data ADAM.AE ;
	Set adae3 ; 
	Proc sort ; by  STUDYID USUBJID AEDECOD AESTDTC;
Run ;

